package no.ntnu.item.arctis.mariubje.rps.lobby;

import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.PrintStream;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.Vector;

import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import no.ntnu.item.arctis.mariubje.rps.data.DeniedMsg;
import no.ntnu.item.ramses.runtime.Scheduler;

public class Lobby {

	JFrame frame;
	JList userJList;
	
	List<String> userList;
	public java.lang.String tempUser;

	public void initialize() {
		userList = new ArrayList<String>();
		
		frame = new JFrame();
		frame.setTitle("Server Lobby");
		frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		frame.setSize(300, 300);
		frame.setLocation(100, 100);
		
		frame.addWindowListener(new WindowListenerImpl());
		
		userJList = new JList();
		frame.getContentPane().add(userJList);
        
		frame.setVisible(true);
	}

	public void destroy() {
		frame.dispose();
        frame = null;
	}

	public boolean userJoin(String userName) {
		if (userName == null || userName.equals("") || userList.contains(userName)) {
			return false;
		}
		else {
			userList.add(userName);
			updateUserJList();
			return true;
		}
	}

	public void userLeft(String userName) {
		userList.remove(userName);
		updateUserJList();
	}
	
	private void updateUserJList() {
		userJList.setListData(userList.toArray());
	}
	
	public boolean userExists(String userName) {
		return userList.contains(userName);
	}

	public String clearAndGetTempUser() {
		String tmp = tempUser;
		tempUser = null;
		return tmp;
	}

	public DeniedMsg getUserDeniedMsgAndClearTempUser() {
		DeniedMsg m = new DeniedMsg();
		m.username = tempUser;
		tempUser = null;
		m.msg = "Username invalid or already in use.";
		return m;
	}

	public List getLobbyList() {
		List l = new Vector();
		l.addAll(userList);
		return l;
	}
	
	private class WindowListenerImpl implements WindowListener {
		@Override
		public void windowActivated(WindowEvent arg0) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void windowClosed(WindowEvent arg0) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void windowClosing(WindowEvent arg0) {
			Scheduler.getRuntime(Lobby.this).sendToMe(Lobby.this, "lobbyClosing");
		}

		@Override
		public void windowDeactivated(WindowEvent arg0) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void windowDeiconified(WindowEvent arg0) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void windowIconified(WindowEvent arg0) {
			// TODO Auto-generated method stub
			
		}

		@Override
		public void windowOpened(WindowEvent arg0) {
			// TODO Auto-generated method stub
			
		}
		
	}

}