package no.ntnu.item.arctis.mariubje.rps.rpssystem;

import no.ntnu.item.ramses.runtime.Scheduler;
import no.ntnu.item.ramses.runtime.routing.GlobalRoutingConstants;
import no.ntnu.item.ramses.runtime.routing.Router;
import no.ntnu.item.ramses.runtime.routing.javase.JavaStandardRouter;
import no.ntnu.item.ramses.runtime.serialization.Serializer;
import no.ntnu.item.ramses.runtime.serialization.SoapHandler;
import no.ntnu.item.ramses.runtime.transport.socket.SocketTransporter;

import no.ntnu.item.arctis.mariubje.rps.rpssystem.gameserver.GameServerSM;

public class Start {

    public static void main(String[] args) {
    	
        /*
         * On a machine, only a single transporter can run on the same port. If
         * another port is used than the default (proposed), the port must be
         * specified when configuring the addresses.
         */
        int socketServerPort = GlobalRoutingConstants.JAVA_STANDARD_TCP_SERVER_PORT;
        
        Serializer serializer = new SoapHandler();
        SocketTransporter transporter = new SocketTransporter(socketServerPort);
        Router router = new JavaStandardRouter(serializer, transporter);
        Scheduler scheduler = new Scheduler(router);
        
        new GameServerSM(scheduler);
        
        new Thread(scheduler).start();
    }
}