package no.ntnu.item.arctis.mariubje.rps.rpssystem.gameserver;

import java.util.Hashtable;

import no.ntnu.item.arctis.mariubje.rps.data.Challenge;
import no.ntnu.item.arctis.mariubje.rps.lobbyguest.lobby.Lobby;
import no.ntnu.item.arctis.mariubje.rps.rpsgame.host.Host;
import no.ntnu.item.arctis.runtime.IFilterableSession;


public class GameServerSM extends java.lang.Object implements no.ntnu.item.ramses.runtime.Scheduler.IStateMachine, no.ntnu.item.arctis.runtime.IFilterableSession {


    protected no.ntnu.item.ramses.runtime.Scheduler scheduler;
    protected java.lang.String _stateMachineID;
    private int _currentState;
    private final static int s_0 = 0;
    private final static int _initial_state = 1;
    private final static int s_1 = 2;
    private final static int s_3 = 3;
    private final static int s_2 = 4;
    private final static int s_4 = 5;
    private final static int s_5 = 6;
    protected no.ntnu.item.arctis.mariubje.rps.rpsgame.host.Host __actions__rpsGame_RpsGame_host;
    protected no.ntnu.item.arctis.mariubje.rps.lobbyguest.lobby.Lobby __actions__lobby_LobbyGuest_lobby;
    protected no.ntnu.item.arctis.mariubje.rps.lobby.Lobby __actions__c0_Lobby_main;
    protected java.lang.String _c0_Lobby_o3_userName;
    protected java.lang.String _c0_Lobby_o2_userName;

    protected GameServerSM() {
    }

    public GameServerSM(no.ntnu.item.ramses.runtime.Scheduler scheduler) {
        this.scheduler = scheduler;
        this._stateMachineID = scheduler.registerMainStateMachine("no.ntnu.item.arctis.mariubje.rps.rpssystem.GameServer", this);
        this.__actions__rpsGame_RpsGame_host = new no.ntnu.item.arctis.mariubje.rps.rpsgame.host.Host();
        this.__actions__lobby_LobbyGuest_lobby = new no.ntnu.item.arctis.mariubje.rps.lobbyguest.lobby.Lobby();
        this.__actions__c0_Lobby_main = new no.ntnu.item.arctis.mariubje.rps.lobby.Lobby();
        this.scheduler.registerActionClass(__actions__rpsGame_RpsGame_host, this);
        this.scheduler.registerActionClass(__actions__lobby_LobbyGuest_lobby, this);
        this.scheduler.registerActionClass(__actions__c0_Lobby_main, this);
    }


    public void fireInitial(){
        System.out.println("Fire Initial called, StateMachine ID: " + getId());
        _currentState = s_0;
        __actions__c0_Lobby_main.initialize();
        _currentState = s_3;
    }

    public int fire(java.lang.Object _sender, Object sessionId, java.lang.String _signalID, java.lang.Object _data){
        System.out.println("Fire Signal called. Signal ID: " + _signalID + ". StateMachine ID: " + getId());
        if(_currentState == s_3) {
            if(_signalID.equals("_lobby_LobbyGuest_challengeAccepted")) {
                no.ntnu.item.arctis.mariubje.rps.data.Challenge _RpsSystem_challengeAccepted = (no.ntnu.item.arctis.mariubje.rps.data.Challenge) _data;
                if (exists1(_RpsSystem_challengeAccepted)) {
                	if (exists2(_RpsSystem_challengeAccepted)) {
                		
                		/*
                         * select roles : 
                         * rpsGame.playerOne.component=[select one : lobby.userName2=flow.challenger].guest 
                         * rpsGame.playerTwo.component=[select one : lobby.userName2=flow.challenged].guest
                         * 
                         * rpsGame maps to rpsGame_host
                         * playerOne/Two maps to _rpsGame_RpsGame_playerOne/Two
                         * lobby maps to lobby_lobby
                         * guest maps to _lobby_LobbyGuest_guest
                         * userName2 is an attribute in an action class
                         * challenger/challenged are attributes in the object flow
                         */
                        
                        IFilterableSession rpsGame_playerOne = null;
                        IFilterableSession[] lobby_lobbys = scheduler.getSessions(this, "lobby_lobby");
                        for (int i = 0; i < lobby_lobbys.length; i++) {
                        	IFilterableSession session = lobby_lobbys[i];
                        	Lobby l = (Lobby)scheduler.getActionClass(session, "no.ntnu.item.arctis.mariubje.rps.lobbyguest.lobby.Lobby");
                        	if (l.userName2.equals(_RpsSystem_challengeAccepted.challenger)) {
                        		rpsGame_playerOne = session;
                        		break;
                        	}
                        }
                        
                        IFilterableSession rpsGame_playerTwo = null;
                        IFilterableSession[] lobby_lobbys2 = scheduler.getSessions(this, "lobby_lobby");
                        for (int i = 0; i < lobby_lobbys2.length; i++) {
                        	IFilterableSession session = lobby_lobbys2[i];
                        	Lobby l = (Lobby)scheduler.getActionClass(session, "no.ntnu.item.arctis.mariubje.rps.lobbyguest.lobby.Lobby");
                        	if (l.userName2.equals(_RpsSystem_challengeAccepted.challenged)) {
                        		rpsGame_playerTwo = session;
                        		break;
                        	}
                        }
                        
                        Hashtable properties = new Hashtable();
                        properties.put("_rpsGame_RpsGame_playerOne_parent", rpsGame_playerOne.getProperty("_lobby_LobbyGuest_guest"));
                        properties.put("_rpsGame_RpsGame_playerTwo_parent", rpsGame_playerTwo.getProperty("_lobby_LobbyGuest_guest"));
                        
                        scheduler.sendToNewLocalSession(this, "rpsGame_host", "_rpsGame_RpsGame_startGame", _RpsSystem_challengeAccepted, properties);
                		
                	}
                }
                _currentState = s_3;
                return no.ntnu.item.ramses.runtime.Scheduler.IStateMachine.CONSUME_SIGNAL;
            } else if(_signalID.equals("_lobby_LobbyGuest_guestDisconnected")) {
                java.lang.String _RpsSystem_guestDisconnected = (java.lang.String) _data;
                _c0_Lobby_o3_userName = _RpsSystem_guestDisconnected;
                __actions__c0_Lobby_main.userLeft(_c0_Lobby_o3_userName);
                scheduler.startTimer(100, "t0", this);
                _currentState = s_3;
                return no.ntnu.item.ramses.runtime.Scheduler.IStateMachine.CONSUME_SIGNAL;
            } else if(_signalID.equals("_lobby_LobbyGuest_challengeDenied")) {
                no.ntnu.item.arctis.mariubje.rps.data.Challenge _RpsSystem_challengeDenied = (no.ntnu.item.arctis.mariubje.rps.data.Challenge) _data;
                _currentState = s_3;
                return no.ntnu.item.ramses.runtime.Scheduler.IStateMachine.CONSUME_SIGNAL;
            } else if(_signalID.equals("lobbyClosing")) {
                __actions__c0_Lobby_main.destroy();
                
                /*
                 * select all (from lobby_lobby)
                 */
                IFilterableSession[] sessions = scheduler.getSessions(this, "lobby_lobby");
                for (int i = 0; i < sessions.length; i++) {
                	IFilterableSession session = sessions[i];
                	scheduler.send(this, session, "_lobby_LobbyGuest_shuttingDownServer");
                }
                
                /*
                 * select all (from rpsGame_host)
                 */
                IFilterableSession[] sessions2 = scheduler.getSessions(this, "rpsGame_host");
                for (int i = 0; i < sessions2.length; i++) {
                	IFilterableSession session = sessions2[i];
                	scheduler.send(this, session, "_rpsGame_RpsGame_stopGame");
                }
                
                scheduler.startTimer(5000, "closing", this);
                
                _currentState = s_3;
                return no.ntnu.item.ramses.runtime.Scheduler.IStateMachine.CONSUME_SIGNAL;
            } else if(_signalID.equals("_lobby_LobbyGuest_chatOutgoing")) {
                no.ntnu.item.arctis.mariubje.rps.data.ChatMessage _RpsSystem_chatOutgoing = (no.ntnu.item.arctis.mariubje.rps.data.ChatMessage) _data;
                if(_RpsSystem_chatOutgoing.toAll == true) {
                	/*
                	 * select all : lobby.EsmState=inLobby
                	 */
                	
                	String[] esmState_inLobby = new String[] { "s_2", "s_201" };
                	IFilterableSession[] sessions = scheduler.getSessions(this, "lobby_lobby");
                	for (int i = 0; i < sessions.length; i++) {
                		IFilterableSession session = sessions[i];
                		if (session.matchOneOfControlStates(esmState_inLobby)) {
                			scheduler.send(this, session, "_lobby_LobbyGuest_chatIncoming", _RpsSystem_chatOutgoing);
                		}
                	}
                	
                    _currentState = s_3;
                    return no.ntnu.item.ramses.runtime.Scheduler.IStateMachine.CONSUME_SIGNAL;
                } else {
                	/*
                	 * select all : lobby.EsmState=inLobby rpsGame.isParticipant(flow.from)
                	 * 
                	 * Should select all from lobby that is:
                	 * - in EsmState inLobby
                	 * AND
                	 * there is a rpsGame-session involving the guest in the lobby-session 
                	 * 		under evaluation that returns true on the operation isParticipant(..) 
                	 * 		with the message-sender as parameter
                	 */
                	String[] esmState_inLobby = new String[] { "s_2", "s_201" };
                	IFilterableSession[] lobby_lobbys = scheduler.getSessions(this, "lobby_lobby");
                	IFilterableSession[] rpsGame_hosts = scheduler.getSessions(this, "rpsGame_host");
                	for (int i = 0; i < lobby_lobbys.length; i++) {
                		IFilterableSession lobby_lobby = lobby_lobbys[i];
                		if (lobby_lobby.matchOneOfControlStates(esmState_inLobby)) {
                			// Lobby-session matches first filter
                			for (int j = 0; j < rpsGame_hosts.length; j++) {
                				IFilterableSession rpsGame_host = rpsGame_hosts[j];
                				if (rpsGame_host.getProperty("_rpsGame_RpsGame_playerOne_parent").equals(lobby_lobby.getProperty("_lobby_LobbyGuest_guest"))
                						|| rpsGame_host.getProperty("_rpsGame_RpsGame_playerTwo_parent").equals(lobby_lobby.getProperty("_lobby_LobbyGuest_guest"))) {
                					// Component from lobby is involved in the RpsGame
                					Host h = (Host)scheduler.getActionClass(rpsGame_host, "no.ntnu.item.arctis.mariubje.rps.rpsgame.host.Host");
                					if (h.isParticipant(_RpsSystem_chatOutgoing.from)) {
                						// Lobby-session matches both filters
                						scheduler.send(this, lobby_lobby, "_lobby_LobbyGuest_privChatIncoming", _RpsSystem_chatOutgoing);
                					}
                				}
                			}
                		}
                	}
                	
                    _currentState = s_3;
                    return no.ntnu.item.ramses.runtime.Scheduler.IStateMachine.CONSUME_SIGNAL;
                }
            } else if(_signalID.equals("_lobby_LobbyGuest_guestLeft")) {
                java.lang.String _RpsSystem_guestLeft = (java.lang.String) _data;
                _c0_Lobby_o3_userName = _RpsSystem_guestLeft;
                
                /*
                 * select all : rpsGame.participates(flow) (from rpsGame)
                 */
                IFilterableSession[] sessions = scheduler.getSessions(this, "rpsGame_host");
                for (int i = 0; i < sessions.length; i++) {
                	IFilterableSession session = sessions[i];
                	Host h = (Host)scheduler.getActionClass(session, "no.ntnu.item.arctis.mariubje.rps.rpsgame.host.Host");
                	if (h.isParticipant(_RpsSystem_guestLeft)) {
                		scheduler.send(this, session, "_rpsGame_RpsGame_stopGame");
                	}
                }
                
                __actions__c0_Lobby_main.userLeft(_c0_Lobby_o3_userName);
                scheduler.startTimer(100, "t0", this);
                _currentState = s_3;
                return no.ntnu.item.ramses.runtime.Scheduler.IStateMachine.CONSUME_SIGNAL;
            } else if(_signalID.equals("_lobby_LobbyGuest_guestChallenges")) {
                no.ntnu.item.arctis.mariubje.rps.data.Challenge _RpsSystem_guestChallenges = (no.ntnu.item.arctis.mariubje.rps.data.Challenge) _data;
                
                /*
                 * select one : lobby.userName2=flow.challenged
                 */
                IFilterableSession[] sessions = scheduler.getSessions(this, "lobby_lobby");
                for (int i = 0; i < sessions.length; i++) {
                	IFilterableSession session = sessions[i];
                	Lobby l = (Lobby)scheduler.getActionClass(session, "no.ntnu.item.arctis.mariubje.rps.lobbyguest.lobby.Lobby");
                	if (l.userName2.equals(_RpsSystem_guestChallenges.challenged)) {
                		scheduler.send(this, session, "_lobby_LobbyGuest_guestChallenged", _RpsSystem_guestChallenges);
                		break; // Only send to one.
                	}
                }

                _currentState = s_3;
                return no.ntnu.item.ramses.runtime.Scheduler.IStateMachine.CONSUME_SIGNAL;
            } else if(_signalID.equals("_rpsGame_RpsGame_gameStopped")) {
                _currentState = s_3;
                return no.ntnu.item.ramses.runtime.Scheduler.IStateMachine.CONSUME_SIGNAL;
            } else if(_signalID.equals("_lobby_LobbyGuest_guestDeniedOk")) {
                _currentState = s_3;
                return no.ntnu.item.ramses.runtime.Scheduler.IStateMachine.CONSUME_SIGNAL;
            } else if(_signalID.equals("_lobby_LobbyGuest_newGuest")) {
                java.lang.String _RpsSystem_newGuest = (java.lang.String) _data;
                __actions__c0_Lobby_main.tempUser = _RpsSystem_newGuest;
                _c0_Lobby_o2_userName = __actions__c0_Lobby_main.tempUser;
                boolean _c0_Lobby_o2_return = __actions__c0_Lobby_main.userJoin(_c0_Lobby_o2_userName);
                if(_c0_Lobby_o2_return==true) {
                    java.lang.String _c0_Lobby_o4_return = __actions__c0_Lobby_main.clearAndGetTempUser();
                    
                    /*
                     * select one : lobby.userName2=flow
                     */
                    IFilterableSession[] sessions = scheduler.getSessions(this, "lobby_lobby");
                    for (int i = 0; i < sessions.length; i++) {
						IFilterableSession session = sessions[i];
						Lobby l = (Lobby)scheduler.getActionClass(session, "no.ntnu.item.arctis.mariubje.rps.lobbyguest.lobby.Lobby");
						if (l.userName2.equals(_c0_Lobby_o4_return)) {
							scheduler.send(this, session, "_lobby_LobbyGuest_guestAccepted", _c0_Lobby_o4_return);
							break;
						}
					}
                    
                    scheduler.startTimer(100, "t0", this);
                    _currentState = s_3;
                    return no.ntnu.item.ramses.runtime.Scheduler.IStateMachine.CONSUME_SIGNAL;
                } else {
                    no.ntnu.item.arctis.mariubje.rps.data.DeniedMsg _c0_Lobby_o5_return = __actions__c0_Lobby_main.getUserDeniedMsgAndClearTempUser();

                    /*
                     * select one : lobby.userName2=flow.msg
                     */
                    IFilterableSession[] sessions = scheduler.getSessions(this, "lobby_lobby");
                    for (int i = 0; i < sessions.length; i++) {
						IFilterableSession session = sessions[i];
						Lobby l = (Lobby)scheduler.getActionClass(session, "no.ntnu.item.arctis.mariubje.rps.lobbyguest.lobby.Lobby");
						if (l.userName2.equals(_c0_Lobby_o5_return.username)) {
							scheduler.send(this, session, "_lobby_LobbyGuest_guestDenied", _c0_Lobby_o5_return);	
						}
					}
                    
                    _currentState = s_3;
                    return no.ntnu.item.ramses.runtime.Scheduler.IStateMachine.CONSUME_SIGNAL;
                }
            }
        } 
        return DISCARD_SIGNAL;
    }

	public int fireTimer(java.lang.String _timerID){
        System.out.println("Fire Timer called. Timer ID: " + _timerID + ". StateMachine ID: " + getId());
        if(_currentState == s_3) {
            if(_timerID.equals("t0")) {
                java.util.List _c0_Lobby_o6_return = __actions__c0_Lobby_main.getLobbyList();

                /*
                 * select all : lobby.EsmState=inLobby
                 */
                String[] esmState_inLobby = new String[] { "s_2", "s_201" };
            	IFilterableSession[] sessions = scheduler.getSessions(this, "lobby_lobby");
            	for (int i = 0; i < sessions.length; i++) {
            		IFilterableSession session = sessions[i];
            		if (session.matchOneOfControlStates(esmState_inLobby)) {
            			scheduler.send(this, session, "_lobby_LobbyGuest_lobbyList", _c0_Lobby_o6_return);
            		}
            	}
                
                _currentState = s_3;
                return no.ntnu.item.ramses.runtime.Scheduler.IStateMachine.CONSUME_SIGNAL;
            } else if (_timerID.equals("closing")) {
            	scheduler.deregisterStateMachine(this);
            }
        }
        return DISCARD_SIGNAL;
    }

    public java.lang.String getId(){
        return this._stateMachineID;
    }

    public no.ntnu.item.ramses.runtime.Scheduler.IStateMachine createSession(java.lang.String partName, String sessionId){
        if(partName.equals("lobby_lobby")) {
            no.ntnu.item.ramses.runtime.Scheduler.IStateMachine lobby_lobby = new no.ntnu.item.arctis.mariubje.rps.rpssystem.gameserver.LobbyGuest_lobbySM(scheduler, this, partName, sessionId);
            return lobby_lobby;
        }
        if(partName.equals("rpsGame_host")) {
            no.ntnu.item.ramses.runtime.Scheduler.IStateMachine rpsGame_host = new no.ntnu.item.arctis.mariubje.rps.rpssystem.gameserver.RpsGame_hostSM(scheduler, this, partName, sessionId);
            return rpsGame_host;
        }
        return null;
    }

    public void setProperty(java.lang.String id, java.lang.Object property){
    }

    public boolean matchOneOfControlStates(java.lang.String[] allowedStates){
        if(allowedStates == null) {
            return false;
        }
        for (int i = 0; i < allowedStates.length; i++) {
        if(new Integer(_currentState).equals(allowedStates[i])) {
            return true;
        }
        }
        return false;
    }

    public Object getProperty(String propertyId) {
    	// TODO Auto-generated method stub
    	return null;
    }
    
    private boolean exists1(Challenge c) {
		/*
		 * Implementation method for:
		 * exists lobby : lobby.userName2=flow.challenger
		 */
    	IFilterableSession[] sessions = scheduler.getSessions(this, "lobby_lobby");
    	for (int i = 0; i < sessions.length; i++) {
			IFilterableSession session = sessions[i];
			Lobby l = (Lobby)scheduler.getActionClass(session, "no.ntnu.item.arctis.mariubje.rps.lobbyguest.lobby.Lobby");
			if (l.userName2.equals(c.challenger)) {
				return true;
			}
		}
		return false;
	}
    
    private boolean exists2(Challenge c) {
    	/*
		 * Implementation method for:
		 * exists lobby : lobby.userName2=flow.challenged
		 */
    	IFilterableSession[] sessions = scheduler.getSessions(this, "lobby_lobby");
    	for (int i = 0; i < sessions.length; i++) {
			IFilterableSession session = sessions[i];
			Lobby l = (Lobby)scheduler.getActionClass(session, "no.ntnu.item.arctis.mariubje.rps.lobbyguest.lobby.Lobby");
			if (l.userName2.equals(c.challenged)) {
				return true;
			}
		}
		return false;
	}
}
