/**
 * 16. jan.. 2009
 */
package no.ntnu.item.ramses.runtime.serialization;


/**
 * @author Marius Bjerke
 */
public abstract class Serializer {

    private static final boolean debug = true;
    
    public abstract String serialize(Object sender, Object receiver, String signalId, Object data);
    
    public abstract MessageObjectsWrapper deserialize(String serializedMessage);

    protected void debug(String text, String method) {
        if (debug) System.out.println(this.getClass().getName() + "." + method + ":\n\t" + text);
    }

    public static class MessageObjectsWrapper {
        
        private final Object sender;
        private final Object receiver;
        private final String signalId;
        private final Object data;
        
        public MessageObjectsWrapper(Object sender, Object receiver, String signalId, Object data) {
            this.sender = sender;
            this.receiver = receiver;
            this.signalId = signalId;
            this.data = data;
        }

        
        public Object getSender() {
            return sender;
        }

        
        public Object getReceiver() {
            return receiver;
        }

        
        public String getSignalId() {
            return signalId;
        }

        
        public Object getData() {
            return data;
        }
    }
}
