/**
 * 
 */
package no.ntnu.item.ramses.runtime.serialization.marshals;

import java.io.IOException;

import org.ksoap2.serialization.Marshal;
import org.ksoap2.serialization.PropertyInfo;
import org.ksoap2.serialization.SoapSerializationEnvelope;
import org.xmlpull.v1.XmlPullParser;
import org.xmlpull.v1.XmlPullParserException;
import org.xmlpull.v1.XmlSerializer;

/**
 * @author Marius
 *
 */
public class JavaMeFloatMarshal implements Marshal {
    
    public static final Class FLOAT_CLASS = new Float(0.0).getClass();
    public static final Class DOUBLE_CLASS = new Double(0.0).getClass();

    public Object readInstance(XmlPullParser parser, String namespace, String name, PropertyInfo propertyInfo) throws IOException, XmlPullParserException {
        String stringValue = parser.nextText();
        Object result;
        if (name.equals("float")) {
            result = new Float(Float.parseFloat(stringValue)); // new Float(stringValue);
        } else if (name.equals("double")) {
            result = new Double(Double.parseDouble(stringValue)); // new Double(stringValue);
        } //else if (name.equals("decimal")) {
            //result = new java.math.BigDecimal(stringValue);
        //} 
        else {
            throw new RuntimeException("float or double expected");
        }
        return result;
    }

    public void writeInstance(XmlSerializer writer, Object instance) throws IOException {
        writer.text(instance.toString());
    }

    public void register(SoapSerializationEnvelope cm) {
        cm.addMapping(cm.xsd, "float", FLOAT_CLASS, this);
        cm.addMapping(cm.xsd, "double", DOUBLE_CLASS, this);
        //cm.addMapping(cm.xsd, "decimal", java.math.BigDecimal.class, this);
    }
    
}
