/**
 * 3. feb.. 2009
 */
package no.ntnu.item.ramses.runtime.serialization.marshals;

import java.io.IOException;

import no.ntnu.item.ramses.runtime.routing.URL;

import org.ksoap2.serialization.Marshal;
import org.ksoap2.serialization.PropertyInfo;
import org.ksoap2.serialization.SoapObject;
import org.ksoap2.serialization.SoapSerializationEnvelope;
import org.xmlpull.v1.XmlPullParser;
import org.xmlpull.v1.XmlPullParserException;
import org.xmlpull.v1.XmlSerializer;


/**
 * @author Marius Bjerke
 *
 */
public class UrlMarshal implements Marshal {

    public java.lang.String NAMESPACE;
    public java.lang.String NAME;
    public java.lang.Class URL_CLASS;
    private org.ksoap2.serialization.SoapSerializationEnvelope envelope;
    
    
    public UrlMarshal() {
        NAMESPACE = "http://www.item.ntnu.no/RAMSES_SOAP";
        NAME = "no.ntnu.item.ramses.runtime.routing.URL";
        URL_CLASS = new URL("item://").getClass();
    }
    
    /* (non-Javadoc)
     * @see org.ksoap2.serialization.Marshal#readInstance(org.xmlpull.v1.XmlPullParser, java.lang.String, java.lang.String, org.ksoap2.serialization.PropertyInfo)
     */
    public Object readInstance(XmlPullParser parser, String namespace, String name,
            PropertyInfo expected) throws IOException, XmlPullParserException {
        String url = "";
        String elementName = parser.getName();
        while (parser.nextTag() != XmlPullParser.END_TAG) {
            if (parser.getName().equals("url")) {
                url = (String)envelope.read(parser, null, 0, null, "", PropertyInfo.OBJECT_TYPE);
            }
        }
        parser.require(XmlPullParser.END_TAG, null, elementName);
        return new URL(url);
    }

    /* (non-Javadoc)
     * @see org.ksoap2.serialization.Marshal#register(org.ksoap2.serialization.SoapSerializationEnvelope)
     */
    public void register(SoapSerializationEnvelope envelope) {
        this.envelope = envelope;
        envelope.addMapping(NAMESPACE, NAME, URL_CLASS, this);
    }

    /* (non-Javadoc)
     * @see org.ksoap2.serialization.Marshal#writeInstance(org.xmlpull.v1.XmlSerializer, java.lang.Object)
     */
    public void writeInstance(XmlSerializer writer, Object instance) throws IOException {
        URL u = (URL)instance;
        SoapObject so = new SoapObject(NAMESPACE, null);
        so.addProperty("url", u.toString());
        envelope.writeObjectBody(writer, so);
    }

}
